=== src/fluent-bit/examples/CMakeLists.txt ===
add_subdirectory(hello_world)
if(FLB_OUT_LIB)
  add_subdirectory(out_lib)
endif()
