=== packaging/repoconfig/debian/changelog ===
netdata-repo (2-2) unstable; urgency=medium

  * Version bump to keep in sync with RPM repo packages

 -- Netdata Builder <bot@netdata.cloud>  Mon, 13 Nov 2023 11:15:00 -0500

netdata-repo (2-1) unstable; urgency=medium

  * Switched to new package hosting infrastructure
  * Removed apt-transport-https requirement

 -- Netdata Builder <bot@netdata.cloud>  Wed, 18 Jan 2023 08:30:00 -0500

netdata-repo (1-2) unstable; urgency=medium

  * Fixed package file naming for repo layout compliance

 -- Netdata Builder <bot@netdata.cloud>  Mon, 6 Jun 2022 09:30:00 -0500

netdata-repo (1-1) unstable; urgency=medium

  * Initial Release

 -- Netdata Builder <bot@netdata.cloud>  Mon, 14 Jun 2021 08:00:00 -0500
