=== contrib/debian/control ===
Source: netdata
Build-Depends: debhelper (>= 10),
               dpkg-dev (>= 1.13.19),
               bison,
               cmake,
               curl,
               flex,
               golang (>= 1.21),
               libcups2-dev,
               libcurl4-openssl-dev,
               libelf-dev,
               libipmimonitoring-dev,
               libjson-c-dev,
               liblz4-dev,
               libmnl-dev,
               libmongoc-dev,
               libnetfilter-acct-dev,
               libpcre2-dev,
               libprotobuf-dev,
               libprotoc-dev,
               libsnappy-dev,
               libssl-dev,
               libsystemd-dev,
               libuv1-dev,
               libyaml-dev,
               pkg-config,
               protobuf-compiler,
               uuid-dev,
               zlib1g-dev
Section: net
Priority: optional
Maintainer: Netdata Builder <bot@netdata.cloud>
Standards-Version: 3.9.6
Homepage: https://netdata.cloud

Package: netdata
Architecture: any
Depends: openssl,
         ${misc:Depends},
         ${shlibs:Depends},
         netdata-plugin-ebpf (= ${source:Version}) [amd64],
         netdata-plugin-apps (= ${source:Version}),
         netdata-plugin-pythond (= ${source:Version}),
         netdata-plugin-go (= ${source:Version}),
         netdata-plugin-debugfs (= ${source:Version}),
         netdata-plugin-nfacct (= ${source:Version}),
         netdata-plugin-chartsd (= ${source:Version}),
         netdata-plugin-slabinfo (= ${source:Version}),
         netdata-plugin-perf (= ${source:Version})
Pre-Depends: adduser,
             dpkg (>= 1.17.14),
             libcap2-bin (>=1:2.0),
             lsb-base (>= 3.1-23.2)
Conflicts: netdata-core,
           netdata-plugins-bash,
           netdata-plugins-python,
           netdata-web
Suggests: netdata-plugin-cups (= ${source:Version}),
          netdata-plugin-freeipmi (= ${source:Version})
Recommends: netdata-plugin-systemd-journal (= ${source:Version}),
            netdata-plugin-logs-management (= ${source:Version}),
            netdata-plugin-network-viewer (= ${source:Version})
Description: real-time charts for system monitoring
 Netdata is a daemon that collects data in realtime (per second)
 and presents a web site to view and analyze them. The presentation
 is also real-time and full of interactive charts that precisely
 render all collected values.

Package: netdata-plugin-cups
Architecture: any
Depends: cups,
         ${shlibs:Depends},
         netdata (= ${source:Version})
Pre-Depends: adduser
Description: The CUPS metrics collection plugin for the Netdata Agent
 This plugin allows the Netdata Agent to collect metrics from the Common
 UNIX Printing System.

Package: netdata-plugin-freeipmi
Architecture: any
Depends: freeipmi,
         ${shlibs:Depends},
         netdata (= ${source:Version})
Pre-Depends: adduser
Description: The FreeIPMI metrics collection plugin for the Netdata Agent
 This plugin allows the Netdata Agent to collect metrics from hardware
 using FreeIPMI.

Package: netdata-plugin-nfacct
Architecture: any
Depends: ${shlibs:Depends},
         netdata (= ${source:Version})
Pre-Depends: adduser
Conflicts: netdata (<< ${source:Version})
Description: The NFACCT metrics collection plugin for the Netdata Agent
 This plugin allows the Netdata Agent to collect metrics from the firewall
 using NFACCT objects.

Package: netdata-plugin-chartsd
Architecture: all
Depends: bash,
         netdata (= ${source:Version})
Pre-Depends: adduser
Conflicts: netdata (<< ${source:Version})
Suggests: apcupsd, iw, sudo
Description: The charts.d metrics collection plugin for the Netdata Agent
 This plugin adds a selection of additional collectors written in shell
 script to the Netdata Agent. It includes collectors for APCUPSD,
 LibreSWAN, OpenSIPS, and Wireless access point statistics.

Package: netdata-plugin-ebpf
Architecture: amd64
Depends: ${shlibs:Depends},
         netdata (= ${source:Version}),
         netdata-ebpf-code-legacy (= ${source:Version})
Pre-Depends: adduser
Recommends: netdata-plugin-apps (= ${source:Version})
Conflicts: netdata (<< ${source:Version})
Description: The eBPF metrics collection plugin for the Netdata Agent
 This plugin allows the Netdata Agent to use eBPF code to collect more
 detailed kernel-level metrics for the system.

Package: netdata-ebpf-code-legacy
Architecture: amd64
Depends: netdata-plugin-ebpf (= ${source:Version})
Pre-Depends: adduser
Conflicts: netdata (<< ${source:Version})
Description: Compiled eBPF legacy code for the Netdata eBPF plugin
 This package provides the pre-compiled eBPF legacy code for use by
 the Netdata eBPF plugin.  This code is only needed when using the eBPF
 plugin with kernel that do not include BTF support (mostly kernel
 versions lower than 5.10)..

Package: netdata-plugin-pythond
Architecture: all
Depends: netdata (= ${source:Version})
Pre-Depends: adduser
Suggests: sudo
Conflicts: netdata (<< ${source:Version})
Description: The python.d metrics collection plugin for the Netdata Agent
 Many of the collectors provided by this package are also available
 in netdata-plugin-god. In msot cases, you probably want to use those
 versions instead of the Python versions.

Package: netdata-plugin-go
Architecture: any
Depends: ${shlibs:Depends},
         netdata (= ${source:Version})
Pre-Depends: libcap2-bin, adduser
Suggests: nvme-cli, sudo
Conflicts: netdata (<< ${source:Version})
Description: The go.d metrics collection plugin for the Netdata Agent
 This plugin adds a selection of additional collectors written in Go to
 the Netdata Agent. A significant percentage of the application specific
 collectors provided by Netdata are part of this plugin, so most users
 will want it installed.

Package: netdata-plugin-apps
Architecture: any
Depends: ${shlibs:Depends},
         netdata (= ${source:Version})
Pre-Depends: libcap2-bin, adduser
Conflicts: netdata (<< ${source:Version})
Description: The per-application metrics collection plugin for the Netdata Agent
 This plugin allows the Netdata Agent to collect per-application and
 per-user metrics without using cgroups.

Package: netdata-plugin-slabinfo
Architecture: any
Depends: ${shlibs:Depends},
         netdata (= ${source:Version})
Pre-Depends: libcap2-bin, adduser
Conflicts: netdata (<< ${source:Version})
Description: The slabinfo metrics collector for the Netdata Agent
 This plugin allows the Netdata Agent to collect perfromance and
 utilization metrics for the Linux kernel’s SLAB allocator.

Package: netdata-plugin-perf
Architecture: any
Depends: ${shlibs:Depends},
         netdata (= ${source:Version})
Pre-Depends: libcap2-bin, adduser
Conflicts: netdata (<< ${source:Version})
Description: The perf metrics collector for the Netdata Agent
 This plugin allows the Netdata to collect metrics from the Linux perf
 subsystem.

Package: netdata-plugin-debugfs
Architecture: any
Depends: ${shlibs:Depends},
         netdata (= ${source:Version})
Pre-Depends: libcap2-bin, adduser
Conflicts: netdata (<< ${source:Version})
Description: The debugfs metrics collector for the Netdata Agent
 This plugin allows the Netdata Agent to collect Linux kernel metrics
 exposed through debugfs.

Package: netdata-plugin-systemd-journal
Architecture: any
Depends: ${shlibs:Depends},
         netdata (= ${source:Version})
Pre-Depends: libcap2-bin, adduser
Conflicts: netdata (<< ${source:Version})
Description: The systemd-journal collector for the Netdata Agent
 This plugin allows the Netdata Agent to present logs from the systemd
 journal on Netdata Cloud or the local Agent dashboard.

Package: netdata-plugin-xenstat
Architecture: amd64 arm64
Depends: ${shlibs:Depends},
         netdata (= ${source:Version})
Pre-Depends: adduser
Conflicts: netdata (<< ${source:Version})
Description: The xenstat plugin for the Netdata Agent
 This plugin allows the Netdata Agent to collect metrics from the Xen
 Hypervisor.

Package: netdata-plugin-logs-management
Architecture: any
Depends: ${shlibs:Depends},
         netdata (= ${source:Version})
Pre-Depends: libcap2-bin, adduser
Conflicts: netdata (<< ${source:Version})
Description: The logs-management plugin for the Netdata Agent
 This plugin allows the Netdata Agent to collect logs from the system
 and parse them to extract metrics.

Package: netdata-plugin-network-viewer
Architecture: any
Depends: ${shlibs:Depends},
         netdata (= ${source:Version})
Pre-Depends: libcap2-bin, adduser
Recommends: netdata-plugin-ebpf (= ${source:Version}) [amd64]
Conflicts: netdata (<< ${source:Version})
Description: The network viewer plugin for the Netdata Agent
 This plugin allows the Netdata Agent to provide network connection
 mapping functionality for use in netdata Cloud.
